gj_colorprofile_day = 0
gj_colorprofile_night = 0
wInpValueInteger_min = 0
wInpValueInteger_max = 0
wUnitConvMeter2Unit = {float.new("1.093613298"), float.new("1.0"), float.new("3.280839895")}
wTemp_overview_distance = nil


sc_start_customize = function()

	gj_colorprofile_day = PERSISTENT.defaultDayMapColorProfile()
	gj_colorprofile_night = PERSISTENT.defaultNightMapColorProfile()
	sc_gjMapchangerProvider_check()
	sc_wBuildCockpitMenu()
	ui.fullCockpitMenuList:sort("menu_index")
	sc_gj_start()
end
 
sc_set_UIresolution()
sc_set_MAPresolution()
if sc_GetSysEntry("utility", "calibratefix", 0) then
	START_APPLICATION("utility/esc.exe","")
	sc_CalibrateScreen()
end

sc_gj_start = function()
--gj start sound
	doDelayed(20, function()
		sc_gjplaysound(MODEL.lua.vgjStartSoundName(), MODEL.lua.vgjStartExitVolume())
	end
	)  
--gj power control
	if MODEL.lua.vgjBatterySoundName() ~= L"" then
		doDelayed(240, function()
			if not MODEL.power.on_acline() then
				sc_gj_power_change()
			end
		end
		)
	end
end


-- start.lua ----------------------------------------------

st_Start.init_orig = st_Start.init
st_Start.init = function()
  sc_BuildMapLocalMenu()
  ui.fullMapLocalMenuList:sort("menu_index")
  sc_LoadTrafficEventTypeSettings()
  MODEL.traffic.events.sort_by(MODEL.lua.trafficEventSorting())
  sc_CreateKeyboardPanelsLocalMenu()
  sc_GetSysEntry_Init()
  if MODEL.lua.Currency() == L"" then
    MODEL.lua.Currency = MODEL.regional.current_language.currency()
  end
  if MODEL.lua.storeDemoMode() ~= 0 then
    obs_store_demo_start:START("NO_TRIGGER")
    obs_store_demo_stop:START("NO_TRIGGER")
  end
  if MODEL.other.debug() then
    obs_saved_parameters_modified = OBSERVER.new({observe = MODEL.route.parameters_modified, onchange = function()
      if MODEL.route.parameters_modified() then
        ASSERT(MODEL.route.vehicle_type() == MODEL.mydata.vehicle_profile.list[MODEL.mydata.vehicle_profile.selected_profile()].vehicle_type())
      else
        MODEL.route.list.navigated.settings.check_consistency_with_global_settings()
        sc_CheckOffroadParams()
      end
    end
    })
  end
  if gSkinDebug then
    REGISTERKEYCODE("PREVTHEME", 33)
    KEY("PREVTHEME", sc_SelectPrevTheme)
    REGISTERKEYCODE("NEXTTHEME", 34)
    KEY("NEXTTHEME", sc_SelectNextTheme)
  end
  MODEL.mydata.tracks.show_on_map = false
  MODEL.route.list.navigated.waypoints.autocreate_start = true
  MODEL.screen.msgbox.pause_tags("popup", true)
  MODEL.regional.keyboard.update_panel_list()
  if MODEL.route.list.navigated.waypoints.start_is_user_selected() then
    MODEL.gps.stop()
    MODEL.navigation.car.position = MODEL.route.list.navigated.waypoints.list[0].real_position()
  else
    MODEL.gps.start()
  end
  sc_UpdateOffroadModelsFromUI()
--  MODEL.other.trips[0].reset()
  sc_SetFavoritesVisibility()
  sc_enable_offroute_recalc()
  EXEC_STARTUP_PARAMS()
  if MODEL.oasis.pictures.slideshow_time() == 0 then
    MODEL.oasis.pictures.slideshow_time = 5
  end
  if MODEL.lua.smallBuild() == 1 and MODEL.lua.vEasyMapMode() == EMapMode.Mode_3D then
    MODEL.lua.vEasyMapMode = EMapMode.Mode_3D
  end
  if sc_start_customize ~= nil then
    sc_start_customize()
  end
  sc_SetCountrySpecTMCIcon()
  MODEL.mydata.history.sort_smart()
  sc_SetEasyDefaulSett()
  sc_Map_States_Init()
  MODEL.lua.dateDelimiter = MODEL.regional.dateformat() % 3
  MODEL.lua.dateFormat = MODEL.regional.dateformat() / 3
  sc_TMC_SearchResult()
  if MODEL.EXISTS.tmc.src.http.enabled() then
    MODEL.lua.OnlineTrafficExists = true
    if MODEL.network.supported() and MODEL.tmc.src.http.enabled() then
      obs_OnlineTrafficError:START()
    else
      MODEL.tmc.src.http.enabled = false
    end
  else
    MODEL.lua.OnlineTrafficExists = false
  end
  sc_ManualDetourGetter()

  MODEL.interface.colorprofile.day_list.index = PERSISTENT.defaultDayMapColorProfile()
  MODEL.interface.colorprofile.night_list.index = PERSISTENT.defaultNightMapColorProfile()
--  
  ATTACHANIMLAYER(uieffect)
  obs_DynamicVolumeTypeChanged:START("NO_TRIGGER")
  sc_Set_DayNightMode()
  if PERSISTENT.vfirst_start_default_settings() then
    sc_first_start_default_settings()
  end
  MODEL.ui.lmHighwaySettings.resize(4)
  MODEL.lua.truckLicensed = MODEL.EXISTS.mydata.truck()
  if L"TMC~Consider" == translate("TMC~Consider") then
    ui.vOldTMC = 1
  else
    ui.vOldTMC = 0
  end
  ui.vOldTMC = 1
  MODEL.oasis.travel.initialize_data()
  if MODEL.lua.vEasyWizModeOnFirstStart() then
    sc_btnASM_ConfigWizard_OnRelease()
  elseif not PERSISTENT.CollectingAsked() then
    sc_CollectLogsAsk()
    STATE(st_collecting_xhtml)
  else
    sc_GoToStartState(false)
  end
  sc_SetVehicleSpecificSettings()
  obs_Tunnel:START("NO_TRIGGER")
  obs_destination:START("NO_TRIGGER")
  if MODEL.EXISTS.other.slapi() then
    obs_slapi_routecalculated:START("NO_TRIGGER")
  end
  MODEL.route.histspeed.use_timeslice = false
  ui_MapLocalMenuListLayer:X(uiResW)
  gUserPOI_Provider = MODEL.poi.find_provider("userpoi")
--gj-ak power mgm
  MODEL.power.powermgm_state = MODEL.lua.vgjPowerMgm()
end


sc_first_start_default_settings_orig = sc_first_start_default_settings
sc_first_start_default_settings = function()
  MODEL.lua.CockpitType = sc_GetSysEntry("css", "cockpit_type", 0)
  MODEL.map.primary.setglobal = true
  MODEL.map.primary["3d_landmarks"] = 1
  MODEL.map.primary["3d_buildings"] = 2
  MODEL.map.primary.setglobal = false
  PERSISTENT.vfirst_start_default_settings = false
--  MODEL.other.trips[0].reset()
--  MODEL.other.trips[1].reset()
  if MODEL.EXISTS.interface.colorprofile.sort() then
    MODEL.interface.colorprofile.list.index = 0
    MODEL.interface.colorprofile.set_current_as(1)
  end
  if MODEL.EXISTS.tmc.src.http.enabled() and MODEL.network.supported() then
    if MODEL.network.quota.server_controlled() then
      obs_OnlineTrafficError:START("NO_TRIGGER")
      MODEL.traffic.settings.traffic_enabled = true
      MODEL.tmc.src.http.enabled = true
    else
      MODEL.tmc.src.http.enabled = false
    end
  elseif MODEL.EXISTS.tmc.src.http.enabled() and not MODEL.network.supported() then
    MODEL.tmc.src.http.enabled = false
  end
  if MODEL.network.quota.limit_per_month() ~= -1 then
    MODEL.lua.UserTrafficLimit = MODEL.network.quota.limit_per_month()
  end
  MODEL.lua.SavedCommunitySpeedcam = MODEL.warning.speedcam.community_speedcam_enabled()
  MODEL.lua.SavedProviderSpeedcam = MODEL.warning.speedcam.provider_speedcam_enabled()
end



sc_reset_primary_orig = sc_reset_primary
sc_reset_primary = function(ResetMapClick)
   primary:X(0)
   primary:Y(0)
   primary:Z(0)
   primary:W(mapResW)
   primary:H(mapResH)
   primary:SCALE(float.new("1.0"))
   if ResetMapClick then
       primary:ONMAPCLICK()
   end
   MODEL.map.primary.show_labels_3d = MODEL.lua.vgjLabels_3d()
   MODEL.map.primary.show_labels_2d = MODEL.lua.vgjLabels_2d()
end

-- common.lua ----------------------------------------------

sc_OnBatteryFast_orig = sc_OnBatteryFast
sc_OnBatteryFast = function()
  sc_gjplaysound(MODEL.lua.vgjBatterySoundName(), MODEL.lua.vgjBatteryVolume())
  gOnBatteryMsgID = sc_InfoMessageBox(m_i18n("External power disconnected. Continuing on battery."), true)
end

sc_OnBatterySlow_orig = sc_OnBatterySlow
sc_OnBatterySlow = function()
  local shutdownTime = sc_GetSysEntry("interface", "shutdown_time", 10)
  if shutdownTime ~= 0 then
	sc_gjplaysound(MODEL.lua.vgjBatterySoundName(), MODEL.lua.vgjBatteryVolume())
    sc_NextStateAnim(st_outofcradlemenu, "horz_scroll", 1, "")
  else
    sc_OnBatteryFast()
  end
end

-- general.lua ---------------------------------------------

ExitState.init_orig = ExitState.init
ExitState.init = function()
  SAVESETTINGS()
  doDelayed(10, function()
	sc_gjplaysound(MODEL.lua.vgjExitSoundName(), MODEL.lua.vgjStartExitVolume())
  end
  )

  if MODEL.lua.vgjBackup() then
--	sc_gjShowHelpText(m_i18n("Automatic backup started!"))
	START_APPLICATION("utility/backup_exit.exe","")
  end

  doDelayed(60, function()
	if tgjSoundVolumeBackup ~= -1 then
		MODEL.sound.alert_volume = tgjSoundVolumeBackup
		tgjSoundVolumeBackup = -1
	end
	EXIT()
  end
  )
end

-- navigatemap.lua ----------------------------------------- 

sc_LaneInfoVisibleOnchange_orig = sc_LaneInfoVisibleOnchange
sc_LaneInfoVisibleOnchange = function()
  if MODEL.lua.laneInfoVisible() then
    sprLaneInfoEasy:BLENDALPHA(0, 32, 20)
	sc_gjplaysound(MODEL.lua.vgjLaneSoundName(), MODEL.lua.vgjLaneSoundVolume())
  else
    sprLaneInfoEasy:BLENDALPHA(32, 0, 20)
  end
end

sc_SignPostLayerShow_orig = sc_SignPostLayerShow
sc_SignPostLayerShow = function()
  if st_EasyNav.active and not MODEL.lua.SignpostVisible() and MODEL.lua.SignpostOn() then
    sc_gjplaysound(MODEL.lua.vgjLaneSoundName(), MODEL.lua.vgjLaneSoundVolume())
--    sc_AngleSignPost()
	sc_Angle_SP()
    MODEL.lua.SignpostVisible = true
    MODEL.lua.showDiriconBg = true
    ui_NavigateMapSingpost:Y(-vLaneInfoSignpostHeight())
    ui_NavigateMapSingpost:YBLEND(0, 15)
  end
  obs_want_junctionview:trigger()
end

sc_SignPostLayerHide_orig = sc_SignPostLayerHide
sc_SignPostLayerHide = function()
  if MODEL.lua.SignpostVisible() then
 --   sc_RestoreSmartZoom()
	sc_Angle_notSP()
    MODEL.lua.SignpostVisible = false
    MODEL.lua.showDiriconBg = false
    ui_NavigateMapSingpost:YBLEND(-vLaneInfoSignpostHeight() - 5, 15)
    MODEL.lua.JunctionViewHiddenByUser = true
  end
  obs_want_junctionview:trigger()
end

-- e_maplayer.lua ----------------------------------------- 

sc_Map_States_Init_orig = sc_Map_States_Init
sc_Map_States_Init = function()
  local mapLayer = MODEL.map.primary()
  for state,initScript in pairs(MapStateInitScripts) do
    mapLayer.enter_state(state)
    initScript(mapLayer)
    mapLayer.save_state(state)
    mapLayer.exit_state()
  end

  sc_gjLabelsReinit2D()
  sc_gjLabelsReinit3D()
  
end
 
 
sc_gjLabelsReinit2D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.setglobal = true
	mapLayer.setglobal_filter = "2dheadup,simulate_2d"
	mapLayer.show_labels_2d = MODEL.lua.vgjLabels_2d()
	mapLayer.setglobal = false
end
 
sc_gjLabelsReinit3D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.setglobal = true
	mapLayer.setglobal_filter = "navmap3d,simulate"
	mapLayer.show_labels_3d = MODEL.lua.vgjLabels_3d()
	mapLayer.navi_mode_3d_labels = MODEL.lua.vgjLabels_navi3d()
	mapLayer.setglobal = false
end


-- local_menu.lua ----------------------------------------- 

sc_BuildMapLocalMenu_orig = sc_BuildMapLocalMenu
sc_BuildMapLocalMenu = function()
	local menuItems = {}
	for i = 0, 7 do
		local itemIdx = sc_FindItemInFullList(PERSISTENT.gj_savedMapLocalMenu[i]())
		MODEL.ui.fullMapLocalMenuList[itemIdx].is_in_menu = true
		MODEL.ui.fullMapLocalMenuList[itemIdx].menu_index = i
	end
end
 
sc_ReplaceSelectedMapLocalMenuItem_orig = sc_ReplaceSelectedMapLocalMenuItem
sc_ReplaceSelectedMapLocalMenuItem = function(itemId)

	local oldId = PERSISTENT.gj_savedMapLocalMenu[vMapMenuButtonAct]()
	local oldItemIdx = sc_FindItemInFullList(oldId)
	local newItemIdx = sc_FindItemInFullList(itemId)
	if MODEL.ui.fullMapLocalMenuList[newItemIdx].is_in_menu() then
		if itemId == oldId then
			return 
		end
		local newItemIdxForSwap = MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index()
		MODEL.ui.fullMapLocalMenuList[oldItemIdx].menu_index = MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index()
		MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedMapLocalMenu[vMapMenuButtonAct] = itemId
		PERSISTENT.gj_savedMapLocalMenu[newItemIdxForSwap] = oldId
	else
		MODEL.ui.fullMapLocalMenuList[oldItemIdx].is_in_menu = false
		MODEL.ui.fullMapLocalMenuList[oldItemIdx].menu_index = 100
		MODEL.ui.fullMapLocalMenuList[newItemIdx].is_in_menu = true
		MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedMapLocalMenu[vMapMenuButtonAct] = itemId
	end
		
end

-- route.lua -----------------------------------------
gNeedDestinationTimer = nil
gDestinationBackIdleTimer = nil
vgAutoAction = nil

sc_wGetTripComputerName = function(i)
	return (i==0 and m_i18n("TRACK_TIME~Current Route") or (i==1 and m_i18n("TRACK_TIME~Statistics") or translated_format(m_i18n("TRACK_TIME~User Trip %s"), towstring(i-1))))
end
 
sc_wTripComputer_OnRelease = function()
	sc_NextStateAnim(st_wTripComputer, "fade", 1, "")
end
 
createState("st_wTripComputer")
st_wTripComputer:useLayers(ui_wTripComputer, backgroundLayers)
st_wTripComputer.init = function()
	txtTitle:SET(m_i18n("Trip Computer"))
end
 
sc_wTripComputerPause = function()
	MODEL.other.trips[index].pause()
end
 
sc_wTripComputerReset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("This will reset this trip."))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wTripComputerResetOK", m_i18n("Trip~Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wTripComputerResetOK = function()
	MODEL.other.trips[MODEL.other.trips.index()].reset()
end



sc_route_finished_Speedcheck_orig = sc_route_finished_Speedcheck
sc_route_finished_Speedcheck = function()
--  if MODEL.navigation.car.current_speed() < 2 and not MODEL.route.list.navigated.calculating() then
  if MODEL.navigation.car.current_speed() < MODEL.lua.vgjAAD_Speed() and not MODEL.route.list.navigated.calculating() then
    gIdleTime_SpeedCheckTime = gIdleTime_SpeedCheckTime + 1
  else
    gIdleTime_SpeedCheckTime = 0
  end
  if gIdleTime_SpeedCheckTime > 5 then
    sc_route_finished_UIObserver()
    obs_destination_speedcheck:STOP()
  end
end

sc_route_finished_UIObserver_orig = sc_route_finished_UIObserver
sc_route_finished_UIObserver = function()

if MODEL.lua.vgjAAD_SoundName() ~= L"" then
	sc_gjplaysound(MODEL.lua.vgjAAD_SoundName(), MODEL.lua.vgjAAD_SoundVolume())
end	


--gj autoshutdown
  if MODEL.lua.vgjAAD_Mode() == 0 then
-- standard mode --

  if vDestinationReachedPopoUpID() == -1 then
    vDestinationReachedPopoUpID:SET(sc_AddMapPopup(2, m_i18n("Have you arrived at your destination?"), "", 0, "sc_GotoDestinationMenu", "", nil, 0))
  end

  elseif MODEL.lua.vgjAAD_Mode() == 1 then
-- gj mode --

--gj auto delete route
    if MODEL.lua.vgjAAD_RoutDel() then
		sc_DeleteRoute()
	end

--gj auto save
    if MODEL.lua.vgjAAD_save() then
		ui.vTripLogSavedAtDestination = true
		MODEL.mydata.tracks.create_from_tripdata(0)
  end

--gj auto exit
	if MODEL.lua.vgjAAD_ShdExit() > 0 then

		doDelayed(30, function()
			vgAutoAction = true
			sc_NextStateAnim(st_DestinationMenu, "horz_scroll", 1, "")
		end
		)
		
	end

  end

end

st_DestinationMenu.init_orig = st_DestinationMenu.init
st_DestinationMenu.init = function()
	txtTitle:SET(m_i18n("Destination Menu"))
	if gNeedDestinationTimer then
		gDestinationBackIdleTimer = 0
		obs_DestinationBackTimer:START("NO_TRIGGER")
		MODEL.ui._reset_idle_timer()
	end
end

st_DestinationMenu.enter_orig = st_DestinationMenu.enter
st_DestinationMenu.enter = function()
    ui.vTripLogSavedAtDestination = false
	gNeedDestinationTimer = true
	MODEL.lua.vgjAADMenuTimer = MODEL.lua.vgjAADMenuTimer()
end

sc_CheckDestinationBackIdleTimer = function()
	if gDestinationBackIdleTimer > MODEL.ui._idle_time() then
		obs_DestinationBackTimer:STOP()
		gNeedDestinationTimer = false
	elseif MODEL.ui._idle_time() >= MODEL.lua.vgjAADMenuTimer() then
		sc_CheckDestinationBackIdleTimerDone()
	else
		gDestinationBackIdleTimer = MODEL.ui._idle_time()
	end
end
 
sc_CheckDestinationBackIdleTimerDone = function()
	obs_DestinationBackTimer:STOP()	
    if not vgAutoAction then
		PLAYSOUND( "!button" )
		sc_PrevStateAnim()
	else
		if MODEL.lua.vgjAAD_ShdExit() == 0 then
			MODEL.power.cancel_shutdown()
			sc_PrevStateAnim()
		elseif MODEL.lua.vgjAAD_ShdExit() == 1 then
			sc_DoExit()
		elseif MODEL.lua.vgjAAD_ShdExit() == 2 then
			sc_PrevStateAnim()
			MODEL.power.shutdown()
		end
	end	
end

sc_GetDestinationBackText = function()
  if MODEL.ui._idle_time() == 0 or not gNeedDestinationTimer then
    return m_i18n("Back")
  end
  return translated_format(m_i18n("Back (%s)"), towstring(MODEL.lua.vgjAADMenuTimer() - MODEL.ui._idle_time()))
end

-- gj -----------------------------------------------------------------------------------------


-- blink
sc_gj_blink = function()

  if MODEL.navigation.has_route() then
	local DestATPETA = MODEL.navigation.eta_at_destination()
	local DestATPTmp = MODEL.lua.vgjATP_TmpTime()
	if DestATPTmp > DestATPETA then
		MODEL.lua.vgjATP_ShowArrTime = (DestATPTmp-DestATPETA)
	else
		MODEL.lua.vgjATP_ShowArrTime = (DestATPTmp-DestATPETA) * -1
	end
  end
  
  if MODEL.lua.routeCalculation() or MODEL.lua.vgjRecalcInfo_Show() then 
  else
    if MODEL.navigation.distance_to_destination() > 0 and gjRI_CalckEvent == 0 then
		MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
		MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination() 
	end	
  end
  
  if vActiveState() == "st_easynav" and wTemp_overview_distance ~= nil then
	sc_overview_check()
  end

end	



-- input integer
createState("st_InputValueInteger")
st_InputValueInteger:useLayers(commonLayers, ui_InputValueInteger)
st_InputValueInteger.init = function()
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_name(L"Core Numbers")
end
 
st_InputValueInteger.done = function()
	KEY("RETURN")
	MODEL.regional.keyboard.on_close_panel()
	MODEL.regional.keyboard.smartkey_model("")
end
 
sc_inpValueInteger_onchange = function()
	local acceptable = false
	local InputKeys = L""
	local inptext = ui.inpValueInteger.VALUE()
	local length = wstring.len(inptext)
	local tempinptext = wstring.sub(inptext, 1, 1) == L"-" and wstring.sub(inptext, 2, length) or inptext
	acceptable, InputKeys = getNextInput_Int(tempinptext, wInpValueInteger_min, wInpValueInteger_max)
	MODEL.lua.keyb_done = acceptable
	MODEL.lua.integerinputkeys = InputKeys
	MODEL.regional.keyboard.smartkey_model("lua.integerinputkeys")
	MODEL.lua.wTmpSign = inptext:len() == 0
end
 
sc_SelectValueInteger = function(title, donefunction, min, max, needsign)
	wInpValueInteger_min = min
	wInpValueInteger_max = max
	local emptytitle = (needsign and (L"-" .. towstring(max)) or towstring(min)) .. L".." .. towstring(max)
	sc_NextStateAnim(st_InputValueInteger, "horz_scroll", 1, "")
	txtTitle:SET(m_i18n(title))
	inpValueInteger:VALUE(L"")
	inpValueInteger:EMPTYTITLE(translated_format(m_i18n("<Enter Number (%s)>"), emptytitle))
	sc_inpValueInteger_onchange()
	KEY("RETURN", donefunction)
	vKeyTableDone:SET(donefunction)
	if needsign then
		ui_wSign:SHOW()
	else
		ui_wSign:HIDE()
	end
end
 
inpValueInteger_isempty = function()
	local result = var.new()
	inpValueInteger:ISEMPTY(result)
	return result()
end



gjRI_CalckEvent = 0

--RecalcInfo 
sc_gj_recalculate_start = function()
	gjRI_CalckEvent = 1
end

sc_gj_recalculate_end = function()

	if MODEL.lua.vgjRI_TmpDist() == 0 or MODEL.lua.vgjRI_TmpTime() == 0 then
		MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
		MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination()
		
--arriv time plan
		MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
		MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
---		MODEL.lua.vgjATP_ShowArrTime = 0
	else

--arriv time plan
		if MODEL.lua.vgjATP_TmpRMethod() ~= MODEL.lua.routeMethodText() then
			MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
			MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
		end

		if (MODEL.lua.vgjRI_TmpDist() ~= MODEL.navigation.distance_to_destination() or MODEL.lua.vgjRI_TmpTime() ~= MODEL.navigation.time_to_destination()) and MODEL.lua.vgjRecalcInfo_Enable() then
			MODEL.lua.vgjRI_ShowTmpDist = MODEL.lua.vgjRI_TmpDist()-MODEL.navigation.distance_to_destination()
			MODEL.lua.vgjRI_ShowTmpTime = MODEL.lua.vgjRI_TmpTime()-MODEL.navigation.time_to_destination()

			doDelayed(30, function()
				if MODEL.navigation.distance_to_destination() > 0 then
					MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
					MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination()
				end
			end
			)
									
			doDelayed(35, function()
				MODEL.lua.vgjRecalcInfo_Show = true
				if MODEL.lua.vgjRISoundName() ~= L"" then
					sc_gjplaysound(MODEL.lua.vgjRISoundName(), MODEL.lua.vgjRISoundVolume())
				end	
			end
			)
			
			killDelayed(gjDel1)
			gjDel1 = doDelayed(800, function()
				MODEL.lua.vgjRecalcInfo_Show = false
			end
			)

		end
	end

	killDelayed(gjDel2)
	gjDel2 = doDelayed(60, function()
		gjRI_CalckEvent = 0
	end
	)
	
end
  

sc_gj_route_end = function()
	MODEL.lua.vgjRI_TmpDist = 0
	MODEL.lua.vgjRI_TmpTime = 0
--arriv time plan
	MODEL.lua.vgjATP_TmpTime = 0
---	MODEL.lua.vgjATP_ShowArrTime = 0
end


sc_gj_reset_atp = function()
--arriv time plan
	MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
	MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
---	MODEL.lua.vgjATP_ShowArrTime = 0
end



sc_gj_atpreset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset time?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_reset_atp", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end


sc_gj_reset_trc = function()
	MODEL.other.trips[0].reset()
end

sc_gj_tripcompreset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset trip computer?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_reset_trc", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end


sc_gj_2d3d = function()
  if MODEL.lua.vEasyMapMode() == 2 then
	MODEL.lua.vEasyMapMode = 1 
  else 
    MODEL.lua.vEasyMapMode = 2
  end
  sc_set_Nav2D3D()
end

-- show play sound --------------------------------------------

sc_gj_plsshow = function()
	if MODEL.lua.vgj_PLSShowEnable() then	
		MODEL.lua.vgj_PLSShow = true
		killDelayed(gjDel4)
		gjDel4 = doDelayed(350, function()
			if MODEL.lua.PLSAutoHide() then
				MODEL.lua.vgj_PLSShow = false
			end	
		end
		)
	end		
end


sc_gj_plsswith = function()
	if MODEL.lua.vgj_PLSShow() then
		MODEL.lua.vgj_PLSShow = false
	else
		sc_gj_plsshow()
	end
end

 
-- all function links -----------------------------------------

sc_MapSettings_BottomMenu = function()
	sc_NextStateAnim(st_gjCustomizeCockpitMenu, "fade", 1, "")
end
 
sc_Show_Calculator = function()
	sc_NextStateAnim(st_Calculator, "fade", 1, "")
end

sc_Quick_mute = function()
	MODEL.sound.os_muted = not MODEL.sound.os_muted()
end 
 
sc_gjStopTrackLog = function()
	sc_StopTrackLog()
end

sc_gjStartTrackLog = function()
	sc_StartTrackLog()
end 
 
sc_Quick_mute_onlongclick = function()
	sc_NextStateAnim(st_VolumeSetting, "fade", 1, "")
end

sc_Quick_record_onlongclick = function()
	sc_NextStateAnim(st_tracklog, "fade", 1, "")
end
 

sc_Quick_FindAddress_onlongclick = function()
	sc_NextStateAnim(st_FindAddress, "horz_scroll", 1, "")
end

sc_gjallsettings_OnRelease = function()
	sc_NextStateAnim(st_EasySettingsMenu, "horz_scroll", 1, "")
end

sc_gjdelroute_OnRelease = function()
	if MODEL.route.list.navigated.waypoints.list.size() > 2 then
		sc_DeleteNextWaypoint()
	else
		sc_map_local_menu_deleteroute()
		vDestinationReachedPopoUpID:SET(-1)
	end
	sc_back_to_cockpit()
	doDelayed(10, function()
		sc_back_to_cockpit()
	end
	)
	
end

-- power control

sc_gj_power_change = function()
	if MODEL.lua.vgjBatterySoundName() ~= L"" then
		if MODEL.power.on_acline() then
			killDelayed(gjpowersw)
			return
		else
			killDelayed(gjpowersw)
			gjpowersw = doDelayed(240, function()
					sc_OnBatteryFast()
				end
			)
		end
	end
end

-- short menu --------------------------------------------------

sc_OpenMapMenu_orig = sc_OpenMapMenu
sc_OpenMapMenu = function()
	MODEL.lua.vEasyNavMapMenuOpen = not MODEL.lua.vEasyNavMapMenuOpen()
    killDelayed(gjopenmenuevent)
    gjopenmenuevent = doDelayed(300, function()
		MODEL.lua.vEasyNavMapMenuOpen = false
	end
	)
end


sc_wBuildCockpitMenu = function()
	local menuItems = {}
	for i = 0, 8 do
		local itemIdx = sc_gjFindItemInCockpitList(PERSISTENT.gj_savedCockpitMenu[i]())
		MODEL.ui.fullCockpitMenuList[itemIdx].is_in_menu = true
		MODEL.ui.fullCockpitMenuList[itemIdx].menu_index = i
	end
end

createState("st_gjCustomizeCockpitMenu")
st_gjCustomizeCockpitMenu:useLayers(primary, uieffect, ui_gjCustomizeCockpitMenu)

createState("st_gjCockpitMenuReplaceList")
st_gjCockpitMenuReplaceList:useLayers(backgroundLayers, ui_gjCockpitMenuReplaceList)
st_gjCockpitMenuReplaceList.init = function()
	txtTitle:SET(m_i18n("Select a Shortcut"))
	ui.fullCockpitMenuList:sort("uniq_id")
end

st_gjCockpitMenuReplaceList.exit = function()
	ui.fullCockpitMenuList:sort("menu_index")
end

sc_gjReplaceSelectedCockpitMenuItem = function(itemId)
	local oldId = PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct]()
	local oldItemIdx = sc_gjFindItemInCockpitList(oldId)
	local newItemIdx = sc_gjFindItemInCockpitList(itemId)
	if MODEL.ui.fullCockpitMenuList[newItemIdx].is_in_menu() then
		if itemId == oldId then
			return 
		end
		local newItemIdxForSwap = MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index()
		MODEL.ui.fullCockpitMenuList[oldItemIdx].menu_index = MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index()
		MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct] = itemId
		PERSISTENT.gj_savedCockpitMenu[newItemIdxForSwap] = oldId
	else
		MODEL.ui.fullCockpitMenuList[oldItemIdx].is_in_menu = false
		MODEL.ui.fullCockpitMenuList[oldItemIdx].menu_index = 100
		MODEL.ui.fullCockpitMenuList[oldItemIdx].cockpitvisible = true
		MODEL.ui.fullCockpitMenuList[newItemIdx].is_in_menu = true
		MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct] = itemId
	end
end

sc_gjFindItemInCockpitList = function(itemId)
	for i = 0, MODEL.ui.fullCockpitMenuList.size() - 1 do
		if MODEL.ui.fullCockpitMenuList[i].id() == itemId then
			return i
		end
	end
	return -1
end

sc_gjOpenCockpitMenuItem = function(index)
	if vActiveState() == "st_easynav" then
		local scriptName = MODEL.ui.fullCockpitMenuList.quick_list[index].onrelease()
		_G[scriptName]()
	else
		vMapMenuButtonAct = index
		sc_NextStateAnim(st_gjCockpitMenuReplaceList, "horz_scroll", 1, "")
	end
end
 
sc_gjOpenLongCockpitMenuItem = function(index)
	local scriptName = MODEL.ui.fullCockpitMenuList.quick_list[index].onlongclick()
	if scriptName == "" then
		sc_gjShowHelpText(MODEL.ui.fullCockpitMenuList.quick_list[index].text())
	else
		_G[scriptName]()
	end
end



-- near speed limit ----------------------------------------------------------------
gjNearSpeed = 0 

sc_gj_Overspeed_on = function()
    if gjNearSpeed == 1 then
		return
	end

	if MODEL.lua.vgjOVSONSoundName() ~= L"" then
	    gjNearSpeed = 1
		sc_gjplaysound(MODEL.lua.vgjOVSONSoundName(), MODEL.lua.vgjOVSONSoundVolume())
	end
	
end


sc_gj_Overspeed_off = function()
    if gjNearSpeed == 0 then
		return
	end

	if MODEL.lua.vgjOVSOFFSoundName() ~= L"" then
	    gjNearSpeed = 0
		sc_gjplaysound(MODEL.lua.vgjOVSOFFSoundName(), MODEL.lua.vgjOVSOFFSoundVolume())
	end

end


-- speedcam on
sc_gj_spcon = function()
    if MODEL.lua.vgjSPCONSoundName() ~= L"" then
	sc_gjplaysound(MODEL.lua.vgjSPCONSoundName(), MODEL.lua.vgjSPCONSoundVolume())
    end	
end

-- speedcam off
sc_gj_spcoff = function()
    if MODEL.lua.vgjSPCOFFSoundName() ~= L"" then
	sc_gjplaysound(MODEL.lua.vgjSPCOFFSoundName(), MODEL.lua.vgjSPCOFFSoundVolume())
    end	
end

-- mapchanger ----------------------------------------------------------------

gjMapProvider = 0 
 
createState("st_gjMapChanger")
st_gjMapChanger:useLayers(backgroundLayers, ui_gjMapChanger)
st_gjMapChanger.init = function()
	txtTitle:SET(m_i18n("MapChanger"))
end

sc_gjMapChanger_OnRelease = function()
	sc_NextStateAnim(st_gjMapChanger, "fade", 1, "")
end

sc_gjMapChanger_go = function(provider)
	if MODEL.lua.vgjMCCurrentMap() ~= provider then
		gjMapProvider = provider
		MODEL.screen.msgbox.new.setup(2)
		MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to change Map provider?"))
		MODEL.screen.msgbox.new.setup_button(1, "sc_gjMapChanger_goDone", m_i18n("Change provider"), L"", "ico_done_mid.bmp#3")
		MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
		MODEL.screen.msgbox.create_new()
	end	
end

sc_gjMapChanger_goDone = function()
	MODEL.lua.vgjMCCurrentMap = gjMapProvider
	local param = "," .. tostring(gjMapProvider)
	NEXTSTATE(RestartState)
	doDelayed(15, function()
		START_APPLICATION("utility/mapchanger.exe",param)
		doDelayed(1,EXIT)
	end
	)
end
 
sc_gjMapchangerProvider_check = function()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L"%content%/map"
	oasisFiles.filter = L"fcategory:1"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_MapsScan_Finished:START("NO_TRIGGER")
end
 
sc_Mapchanger_check_done = function()
	obs_Files_MapsScan_Finished:STOP()
	local name = L""
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		name = MODEL.oasis.files.list[i].fname()
		if name == L"!map_ta.txt" or name == L"!MAP_TA.TXT" then
			MODEL.lua.vgjMCCurrentMap = 1
			break
		end
		if name == L"!map_nt.txt" or name == L"!MAP_NT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 2
			break
		end
		if name == L"!map_ot.txt" or name == L"!MAP_OT.TXT" then
			MODEL.lua.vgjMCCurrentMap = 3
			break
		end
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
end

-- other ----------------------------------------------------------------

sc_gjShowHelpText = function(text)
	txtHelpText:TEXT(text)
	if gjShowHelpTextTimer ~= -1 then
		killDelayed(gjShowHelpTextTimer )
		gjShowHelpTextTimer = -1
	end
	ui_gjHelpText:SHOW()
	gjShowHelpTextTimer = doDelayed(100, function()
		ui_gjHelpText:HIDE()
	end
	)
end

-- programs -------------------------------------------------------------
gjSelectProgramMode = false

sc_gj_ExternalPrograms_OnRelease = function()
	gjSelectProgramMode = false
	sc_NextStateAnim(st_gjUserPrograms, "fade", 1, "")
end

createState("st_gjUserPrograms")
st_gjUserPrograms:useLayers(backgroundLayers, ui_gjUserPrograms)
st_gjUserPrograms.init = function()
	txtTitle:SET(m_i18n("Select program"))
end
 
sc_gj_UserProgramsOnRelease = function()
	local current = MODEL.ui.gjUserProgramList[MODEL["*"]._index()]
	if gjSelectProgramMode then
		MODEL.lua.gjMenuLCProgram = MODEL["*"]._index()
		sc_back()
	elseif current.exit() then
		NEXTSTATE(RestartState)
		doDelayed(15, function()
			START_APPLICATION(current.path(),current.parameter())
			doDelayed(1,EXIT)
		end
		)
	else
		START_APPLICATION(current.path(),current.parameter())
	end
end
 
sc_gj_UserProgramsEdit_OnRelease = function()
	local current = MODEL.ui.gjUserProgramList[MODEL["*"]._index()]
	sc_gjUserProgramsEdit_OnRelease = MODEL["*"]._index()
	MODEL.lua.gjProgramName = current.name()
	MODEL.lua.gjSettingProgramParameter = current.parameter()
	MODEL.lua.gjSettingProgramExOn = current.exit()
	sc_NextStateAnim(st_gjUserProgramsEdit, "horz_scroll", 1, "")
end
 
createState("st_gjUserProgramsEdit")
st_gjUserProgramsEdit:useLayers(backgroundLayers, ui_gjUserProgramsEdit)
st_gjUserProgramsEdit.init = function()
	txtTitle:SET(m_i18n("Edit program entry"))
end
 
st_gjUserProgramsEdit.exit = function()
	local current = MODEL.ui.gjUserProgramList[sc_gjUserProgramsEdit_OnRelease]
	current.name = MODEL.lua.gjProgramName()
	current.parameter = MODEL.lua.gjSettingProgramParameter()
	current.exit = MODEL.lua.gjSettingProgramExOn()
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_EditProgramName = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.lua.gjProgramName())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter program name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_gj_EditProgramNameDone)
	inputFieldRequired = false
	txtTitle:SET(m_i18n("Set program name"))
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_EditProgramParameter = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.lua.gjSettingProgramParameter())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter program parameter>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_gj_EditProgramParameterDone)
	inputFieldRequired = false
	txtTitle:SET(m_i18n("Set program parameter"))
	sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end
 
sc_gj_EditProgramNameDone = function()
	MODEL.lua.gjProgramName = ui.inpSI_Text.VALUE()
	sc_back()
end

sc_gj_EditProgramParameterDone = function()
	MODEL.lua.gjSettingProgramParameter = ui.inpSI_Text.VALUE()
	sc_back()
end
 
sc_gj_UserProgramsDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this program from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_UserProgramsDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_UserProgramsDel_OnRelease_OK = function()
	MODEL.ui.gjUserProgramList.remove(MODEL.ui.gjUserProgramList.list.index())
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_UserProgramsAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all programs from list?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_UserProgramsAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_UserProgramsAll_OnRelease_OK = function()
	MODEL.ui.gjUserProgramList.clear()
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_RescanwUserPrograms_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The previous list will be removed. Are you sure you want to rescan programs?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_RescanwUserPrograms_OnReleaseOK", m_i18n("Rescan programs"), L"", "ico_Done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gj_RescanwUserPrograms_OnReleaseOK = function()
	ui_gjProgramScanning:SHOW()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L""
	oasisFiles.filter = L"fcategory:2"
	oasisFiles.filter_type = L"PROGRAM"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_UserProgramScan_Finished:START("NO_TRIGGER")
end
 
sc_gj_RescanwUserPrograms_done = function()
	obs_Files_UserProgramScan_Finished:STOP()
	ui_gjProgramScanning:HIDE()
	MODEL.ui.gjUserProgramList.clear()
	local filename = L""
	local fpath = L""
	local length = 0
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		filename = MODEL.oasis.files.list[i].fname()
		fpath = MODEL.oasis.files.list[i].frootpath()
		length = wstring.len(fpath)
		fpath = wstring.sub(fpath, 7, length)
		ui.gjUserProgramList:add({name=filename, path=fpath, parameter=L"", exit=0})
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	MODEL.ui.gjUserProgramList.save()
end
 
sc_gj_RescanwUserPrograms_stop = function()
	obs_Files_UserProgramScan_Finished:STOP()
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	ui_gjProgramScanning:HIDE()
end


-- settings

createState("st_gj_Settings")
st_gj_Settings:useLayers(backgroundLayers, ui_gj_Settings)
st_gj_Settings.init = function()
	txtTitle:SET(m_i18n("GJ Settings"))
end

sc_btnASM_gj_OnRelease = function()
  sc_NextStateAnim(st_gj_Settings, "horz_scroll", 1, "")
end


-- transparecy settings

createState("st_gj_transprency_Settings")
st_gj_transprency_Settings:useLayers(backgroundLayers, ui_gj_transprency_Settings)
st_gj_transprency_Settings.init = function()
  txtTitle:SET(m_i18n("Transparency Settings"))
end

sc_gj_transprency_OnRelease = function()
  sc_NextStateAnim(st_gj_transprency_Settings, "horz_scroll", 1, "")
end


-- sound play
tgjUserSoundType = ""
tgjSoundPlayed = -1
tgjSoundVolumeBackup = -1


createState("st_gj_sound_Settings")
st_gj_sound_Settings:useLayers(backgroundLayers, ui_gj_sound_Settings)
st_gj_sound_Settings.init = function()
  txtTitle:SET(m_i18n("Warning Settings"))
end

sc_gj_sound_OnRelease = function()
  sc_NextStateAnim(st_gj_sound_Settings, "horz_scroll", 1, "")
end


createState("st_gjUserSounds")
st_gjUserSounds:useLayers(backgroundLayers, ui_gjUserSounds)
st_gjUserSounds.init = function()
	txtTitle:SET(m_i18n("Select sound"))
end
 
sc_gjUserSoundsOnRelease = function()
	local name = MODEL["*"].name()
	local volume = 0
	if tgjUserSoundType == "Laneinfo" then
		MODEL.lua.vgjLaneSoundName = name
		volume = MODEL.lua.vgjLaneSoundVolume()
	elseif tgjUserSoundType == "Start" then
		MODEL.lua.vgjStartSoundName = name
		volume = MODEL.lua.vgjStartExitVolume()
	elseif tgjUserSoundType == "Exit" then
		MODEL.lua.vgjExitSoundName = name
		volume = MODEL.lua.vgjStartExitVolume()
	elseif tgjUserSoundType == "Battery" then
		MODEL.lua.vgjBatterySoundName = name
		volume = MODEL.lua.vgjBatteryVolume()
	elseif tgjUserSoundType == "Autoarrive" then
		MODEL.lua.vgjAAD_SoundName = name
		volume = MODEL.lua.vgjAAD_SoundVolume()
	elseif tgjUserSoundType == "Recalculate" then
		MODEL.lua.vgjRISoundName = name
		volume = MODEL.lua.vgjRISoundVolume()
	elseif tgjUserSoundType == "ovrspeedon" then
		MODEL.lua.vgjOVSONSoundName = name
		volume = MODEL.lua.vgjOVSONSoundVolume()
	elseif tgjUserSoundType == "ovrspeedoff" then
		MODEL.lua.vgjOVSOFFSoundName = name
		volume = MODEL.lua.vgjOVSOFFSoundVolume()
	elseif tgjUserSoundType == "spcoff" then
		MODEL.lua.vgjSPCOFFSoundName = name
		volume = MODEL.lua.vgjSPCOFFSoundVolume()
	elseif tgjUserSoundType == "spcon" then
		MODEL.lua.vgjSPCONSoundName = name
		volume = MODEL.lua.vgjSPCONSoundVolume()
	elseif tgjUserSoundType == "city" then
		MODEL.lua.vgjCitySoundName = name
		volume = MODEL.lua.vgjCitySoundVolume()
	end
	sc_back()
	sc_gjplaysound(name, volume)
end
 
sc_gjUserSoundsPlay_OnRelease = function()
	sc_gjplaysound(MODEL["*"].name(), 65)
end
 
sc_gjUserSoundsDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this User sound from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].name())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserSoundsDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gjUserSoundsDel_OnRelease_OK = function()
	MODEL.ui.gjUserSoundList.remove(MODEL.ui.gjUserSoundList.list.index())
	MODEL.ui.gjUserSoundList.save()
end
 
sc_gjUserSoundsAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all User sounds from list?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserSoundsAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_gjUserSoundsAll_OnRelease_OK = function()
	MODEL.ui.gjUserSoundList.clear()
	MODEL.ui.gjUserSoundList.save()
end
 
sc_RescanwUserSounds_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The previous list will be removed. Are you sure you want to rescan user sounds?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_RescanwUserSounds_OnReleaseOK", m_i18n("Rescan sounds"), L"", "ico_Done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_RescanwUserSounds_OnReleaseOK = function()
	ui_gjSoundScanning:SHOW()
	local oasisFiles = MODEL.oasis.files()
	oasisFiles.useful_dirs_only = true
	oasisFiles.selectable_dir = true
	oasisFiles.unroll_dirs = true
	oasisFiles.path = L"%app%/ui_igo9/audio"
	oasisFiles.filter = L"fcategory:5"
	oasisFiles.create_file_props = false
	oasisFiles.initialize_data()
	obs_Files_UserSoundScan_Finished:START("NO_TRIGGER")
end
 
 
sc_RescanwUserSounds_done = function()
	obs_Files_UserSoundScan_Finished:STOP()
	ui_gjSoundScanning:HIDE()
	MODEL.ui.gjUserSoundList.clear()
	ui.gjUserSoundList:add({name=L""})
	local filename = L""
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		filename = MODEL.oasis.files.list[i].fname()
		filename = wstring.gsub(filename, L".wav", L"")
		filename = wstring.gsub(filename, L".WAV", L"")
		ui.gjUserSoundList:add({name=filename})
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	MODEL.ui.gjUserSoundList.save()
end
 
 
sc_RescanwUserSounds_stop = function()
	obs_Files_UserSoundScan_Finished:STOP()
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	ui_gjSoundScanning:HIDE()
end
 
sc_gjplaysound = function(sound, volume)
	if sound == L"" then
		return
	end
	if tgjSoundPlayed ~= -1 then
		killDelayed(tgjSoundPlayed)
		tgjSoundPlayed = -1
	end
	if tgjSoundVolumeBackup == -1 then
		tgjSoundVolumeBackup = MODEL.sound.alert_volume()
	end
	if MODEL.sound.alert_volume() ~= volume then
		MODEL.sound.alert_volume = volume
	end
	MODEL.sound.playchanneltest("alarmeffect", sound)
	tgjSoundPlayed = doDelayed(100, function()
		if tgjSoundVolumeBackup ~= -1 then
			MODEL.sound.alert_volume = tgjSoundVolumeBackup
			tgjSoundVolumeBackup = -1
		end
	end
	)
end

-- route settings

createState("st_gj_arrive_settings")
st_gj_arrive_settings:useLayers(backgroundLayers, ui_gj_arrive_settings)
st_gj_arrive_settings.init = function()
  txtTitle:SET(m_i18n("Arrive Settings"))
end

sc_gj_arrive_OnRelease = function()
  sc_NextStateAnim(st_gj_arrive_settings, "horz_scroll", 1, "")
end


createState("st_gj_more_settings")
st_gj_more_settings:useLayers(backgroundLayers, ui_gj_more_settings)
st_gj_more_settings.init = function()
  txtTitle:SET(m_i18n("More Settings"))
end

sc_gj_more_OnRelease = function()
  sc_NextStateAnim(st_gj_more_settings, "horz_scroll", 1, "")
end


createState("st_gj_speedcam_settings")
st_gj_speedcam_settings:useLayers(backgroundLayers, ui_gj_speedcam_settings)
st_gj_speedcam_settings.init = function()
  txtTitle:SET(m_i18n("SpeedCam Settings"))
end

sc_gj_speedcam_OnRelease = function()
  sc_NextStateAnim(st_gj_speedcam_settings, "horz_scroll", 1, "")
end


createState("st_gj_route_settings")
st_gj_route_settings:useLayers(backgroundLayers, ui_gj_route_settings)
st_gj_route_settings.init = function()
  txtTitle:SET(m_i18n("Route Settings"))
end

sc_gj_route_OnRelease = function()
  sc_NextStateAnim(st_gj_route_settings, "horz_scroll", 1, "")
end


-- TMC manual tuning
sc_TMCTuning_Up = function()
  MODEL.tmc.tuner_step_up()
end

sc_TMCTuning_Down = function()
  MODEL.tmc.tuner_step_down()
end

sc_TMCTuning_SearchUp = function()
  MODEL.tmc.tuner_search_up()
end

sc_TMCTuning_SearchDown = function()
  MODEL.tmc.tuner_search_down()
end

sc_TMCTuning_Auto = function()
  if MODEL.tmc.auto_tuning() == true then
      MODEL.tmc.auto_tuning = false
  else
      MODEL.tmc.auto_tuning = true
  end
--  sc_close_local_menu()
end

--gj panic
sc_gjm_enable_panic = function()
  if MODEL.warning.speedcam_warning() then
	MODEL.screen.msgbox.new.setup(3)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("SpeedCam Database"))
    MODEL.screen.msgbox.new.setup_button(1, "sc_gjm_move_panic", m_i18n("Move"), "", "ico_minimize.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_gjm_delete_panic", m_i18n("Delete"), "", "ico_cancel_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(3, "sc_back_to_cockpit", m_i18n("Cancel"), "", "")
  else
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("SpeedCam Database"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjm_restore_panic", m_i18n("Restore"), L"", "ico_done_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_back_to_cockpit", m_i18n("Cancel"), L"", "")
  end
	MODEL.screen.msgbox.create_new()
end

sc_gjm_move_panic = function()
	sc_SpeedcamWarningDisabled()
	NEXTSTATE(RestartState)
	doDelayed(50, function()
	START_APPLICATION("./utility/utility.exe",",1,")
		doDelayed(1,EXIT)
	end
	)
end

sc_gjm_delete_panic = function()
	sc_SpeedcamWarningDisabled()
	NEXTSTATE(RestartState)
	doDelayed(50, function()
	START_APPLICATION("./utility/utility.exe",",2,")
		doDelayed(1,EXIT)
	end
	)
end

sc_gjm_restore_panic = function()
	sc_SpeedcamWarningEnabled()
	NEXTSTATE(RestartState)
	doDelayed(50, function()
	START_APPLICATION("./utility/utility.exe",",3,")
		doDelayed(1,EXIT)
	end
	)
end


--colorprofile fix
sc_Set_DayNightMode_orig = sc_Set_DayNightMode
sc_Set_DayNightMode = function()
	if vActiveState() == "st_start" then
		PERSISTENT.defaultDayMapColorProfile = gj_colorprofile_day
		PERSISTENT.defaultNightMapColorProfile = gj_colorprofile_night
		MODEL.interface.colorprofile.day_list.index = gj_colorprofile_day
		MODEL.interface.colorprofile.night_list.index = gj_colorprofile_night
	end
	sc_gjReSet_DayNightMode()
	if vActiveState() == "st_start" then
		MODEL.map.auto_nightmode = false
		MODEL.screen.nightmode = not MODEL.screen.nightmode()
		sc_gjReSet_DayNightMode()
	end
end

sc_gjReSet_DayNightMode = function()
	local easyColorMode = MODEL.lua.vEasyColorMode()
	if easyColorMode == 0 then
		MODEL.map.auto_nightmode = false
		MODEL.screen.nightmode = false
	elseif easyColorMode == 1 then
		MODEL.map.auto_nightmode = false
		MODEL.screen.nightmode = true
	elseif easyColorMode == 2 then
		MODEL.map.auto_nightmode = true
	end
end


--common.lua

st_SimpleInputText.done_orig = st_SimpleInputText.done
st_SimpleInputText.done = function()
	KEY("RETURN")
	inpSI_Text:MAXLENGTH(30)
	MODEL.regional.keyboard.on_close_panel()
	inputFieldRequired = false
	inputFieldRequired_space = false
	MODEL.lua.keyb_space = true
	MODEL.lua.keyb_done = true
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(L"")
	MODEL.lua.wLocalMenuHide = false
end
 

--poi.lua

wCurrentGroup = 0
wCurrentGroupFav = -1
wAddPOIposition	= 0
wLastScrollPos = 0
wBackfromVisibility = false
wGroupIcon = nil
 
sc_Go_PicturePoiList_orig = sc_Go_PicturePoiList
sc_Go_PicturePoiList = function()
	if MODEL.lua.featured_provider() ~= "" then
		sc_close_local_menu()
	end
	sc_ExecuteFlatSearch(poi_search_params.picturepoi_search)
	sc_NextStateAnim(st_FindPOIFlatList, "fade")
end
 
st_LoadPOIVisibilities.init_orig = st_LoadPOIVisibilities.init
st_LoadPOIVisibilities.init = function()
	MODEL.lua.wLocalMenuHide = true
	txtTitle:SET(m_i18n("Load Place Marker Settings"))
end
 
st_LoadPOIVisibilities.done = function()
	MODEL.lua.wLocalMenuHide = false
end
 
sc_PoiVisibilityListClearAll_OnRelease_orig = sc_PoiVisibilityListClearAll_OnRelease
sc_PoiVisibilityListClearAll_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all Place Marker configurations?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_PoiVisibilityClearAll_OnRelease_OK", m_i18n("Delete All"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
st_POIVisibilities.enter_orig = st_POIVisibilities.enter
st_POIVisibilities.enter = function()
	EPoiScrollPos = {}
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
end
 
st_POIVisibilities.init_orig = st_POIVisibilities.init
st_POIVisibilities.init = function()
	sc_SetTitlePOIVisibilities()
	sc_init_local_menu("ui.lm_moremenu_poi_visibilities")
	if wBackfromVisibility then
		wBackfromVisibility = false
		local LastScrollPos = EPoiScrollPos[table.maxn(EPoiScrollPos)]
		wLastScrollPos = LastScrollPos
		local structure = MODEL.poi.structure
		table.remove(EPoiScrollPos)
		structure.to_parent()
		structure.execute()
		doDelayed(1, function()
			MODEL.ui.lst_PoiVisList.scroll_pos = LastScrollPos
		end
		)
	end
end
 
st_POIVisibilities.done_orig = st_POIVisibilities.done
st_POIVisibilities.done = function()
	wBackfromVisibility = false
	sc_SavePOIVisibility()
end
 
sc_back_POIGroupVisibility = function()
	wBackfromVisibility = true
	sc_back()
end
 
sc_ManagePOIGroupVisibility = function(mode)
	table.insert(EPoiScrollPos, MODEL.ui.lst_PoiVisList.scroll_pos())
	local structure = MODEL.poi.structure
	structure.group_list.index = MODEL["*"]._index()
	structure.to_child()
	structure.execute()
	wCurrentGroup = structure.search_root()
	MODEL.my.poi.select_group(MODEL.poi.structure.search_root())
	sc_NextStateAnim(st_ManagePOIGroupVisibility, "horz_scroll", 1, "")
end
 
sc_ChangeCurrentPoiGroupIcon = function(group)
	wGroupIcon = group
	if not sc_GetSysEntry("poi", "sort_icons", 1) then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
	elseif MODEL.ui.list_wScreenIcons.isempty() then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
		local iconbmp, iconphase = nil, nil
		for i = 0, MODEL.screen.icons.size() - 1 do
			iconbmp, iconphase = MODEL.screen.get_icon_file_and_phase(MODEL.screen.icons[i](), 2)
			if not (string.sub(iconbmp,1,1) == "*" or string.sub(iconbmp,1,1) == ";") then
				ui.list_wScreenIcons:add({bmp=iconbmp, phase=iconphase, icon=MODEL.screen.icons[i]()})
			end
		end
		ui.list_wScreenIcons:sort("phase")
		ui.list_wScreenIcons:sort("bmp")
	end
	sc_NextStateAnim(st_ManagePOIGroupIcon, "horz_scroll", 1, "")
end

sc_CurrentPoiGroupIconSelected = function()
	if wGroupIcon then
		MODEL.my.poi.current_group.icon = MODEL["*"].icon()
	else
		MODEL.my.poi.current.icon = MODEL["*"].icon()
	end
	sc_back()
end

createState("st_ManagePOIGroupVisibility")
st_ManagePOIGroupVisibility:useLayers(commonLayers, ui_ManagePOIGroupVisibility)
st_ManagePOIGroupVisibility.init = function()
	txtTitle:SET(m_i18n("Set Place Visibility"))
	MODEL.lua.wCurrentGroupFavourite = (wCurrentGroup == wCurrentGroupFav)
	MODEL.lua.wPoiGroupAltitude = MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at()
	btn_Footer_back_1:ONRELEASE(sc_back_POIGroupVisibility)
end
 
st_ManagePOIGroupVisibility.done = function()
	MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at = MODEL.lua.wPoiGroupAltitude()
	sc_SavePOIVisibility()
	btn_Footer_back_1:ONRELEASE(sc_back)
end
 
createState("st_ManagePOIGroupIcon")
st_ManagePOIGroupIcon:useLayers(commonLayers, ui_ManagePOIGroupIcon)
st_ManagePOIGroupIcon.init = function()
	txtTitle:SET(m_i18n("Select Place Icon"))
end
 
st_ShowPOIInfo.enter = function()
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
end
sc_Poi_Visibilities_orig = sc_Poi_Visibilities
sc_Poi_Visibilities = function()
	sc_SetPoiVisibilities()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	MODEL.lua.poi.selectedPOIVis = MODEL.poi.structure.visibility_array()
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
	sc_NextStateAnim(st_POIVisibilities, "horz_scroll", 1, "")
end

sc_AddPOI = function()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
	sc_NextStateAnim(st_AddPOI, "fade", 1, "")
end

createState("st_AddPOI")
st_AddPOI:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_AddPOI.enter = function()
	EPoiScrollPos = {}
end

st_AddPOI.init = function()
	sc_wSetTitle_AP()
end

sc_Structure_ToChildAP = function()
	table.insert(EPoiScrollPos, MODEL.ui.lst_AP.scroll_pos())
	local structure = MODEL.poi.structure
	structure.group_list.index = MODEL["*"]._index()
	structure.to_child()
	structure.execute()
	MODEL.ui.lst_AP.scroll_pos = 0
	sc_wSetTitle_AP()
end

sc_Structure_ToParentAP = function()
	local structure = MODEL.poi.structure
	local LastScrollPos = EPoiScrollPos[table.maxn(EPoiScrollPos)]
	table.remove(EPoiScrollPos)
	structure.to_parent()
	structure.execute()
	sc_wSetTitle_AP()
	doDelayed(1, function()
		MODEL.ui.lst_AP.scroll_pos = LastScrollPos
	end
	)
end

sc_wSetTitle_AP = function()
	local title = translate(m_i18n("Add POI")) .. (MODEL.poi.structure.parent_name() and	L" - " or L"") .. MODEL.poi.structure.parent_name()
	local titlealt = translate(m_i18n("Select group")) .. (MODEL.poi.structure.parent_name() and	L" - " or L"") .. MODEL.poi.structure.path_text()
	if vActiveState() == "st_addpoi" then
		txtTitle:SET(title)
	else
		txtTitle:SET(titlealt)
	end
end

sc_CreateNewGroupMainAP = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(L"")
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI group name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_CreateNewGroupDoneAP)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("Create POI Group"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
	MODEL.regional.keyboard.load_panel_by_name(L"QWERTY")
	MODEL.lua.wLocalMenuHide = true
end
 
sc_CreateNewGroupDoneAP = function()
	name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New Group>"
	end
	name = "@"..tostring(name)
	name = m_i18n(name)
	MODEL.my.poi.add_group(MODEL.poi.structure.search_root(), MODEL.poi.find_provider("userpoi"), name)
 	MODEL.poi.structure.execute()
	PREVSTATE()
end
 
sc_AddPOIToGroupMain = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(L"")
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_SetNewPOIName)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("Create POI"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_SetNewPOIName = function()
	local name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New POI>"
	end
	MODEL.my.poi.add_poi_selected(MODEL.poi.structure.search_root(), MODEL.poi.find_provider("userpoi"))
	MODEL.my.poi.current.name = name
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	sc_SelectSavedFavorites()
	PREVSTATE()
	PREVSTATE()
	NEXTSTATE(st_ShowPOIInfo)
end

sc_ModifyPOINameMain = function()
	sc_close_local_menu()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.my.poi.current.name())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI name>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_ModifyPOIName)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("New POI name"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_ModifyPOIName = function()
	local name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New POI>"
	end
	MODEL.my.poi.current.name = name
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	PREVSTATE()
end

sc_ModifyPOIPhoneMain = function()
	sc_close_local_menu()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:VALUE(MODEL.my.poi.current.phone())
	inpSI_Text:EMPTYTITLE(m_i18n("<Enter new POI phone number>"))
	MODEL.lua.easyShowDoneKey = true
	vKeyTableDone:SET(sc_ModifyPOIPhone)
	inputFieldRequired = true
	txtTitle:SET(m_i18n("New POI phone number"))
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
	MODEL.regional.keyboard.load_panel_by_name(L"Phone")
	MODEL.lua.wLocalMenuHide = true
end

sc_ModifyPOIPhone = function()
	MODEL.my.poi.current.phone = ui.inpSI_Text.VALUE()
	PREVSTATE()
end

sc_wLMDeletePOI = function()
	local text2 = MODEL.my.map.selected_item.name()
	local newMsgBox = MODEL.screen.msgbox.new
	newMsgBox.setup(2)
	newMsgBox.set_line(1, m_i18n("Are you sure you want to delete this POI?"))
	newMsgBox.set_line_wstr(2, text2)
	newMsgBox.setup_button(1, "sc_wLMDeletePOI_OK", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	newMsgBox.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wLMDeletePOI_OK = function()
	MODEL.my.poi.current.remove()
	MODEL.poi.resultpoi.clear()
	MODEL.my.map.select_address(MODEL.map.cursor.position())
	sc_ResetStrappedCursor()
	if vActiveState() == "st_easynav" then
		sc_start_ExitDragMode()
	end
end

sc_DeletePoiGroup = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete Group and all POIs in this Group?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_DeletePoiGroupDone", m_i18n("Delete"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end

sc_DeletePoiGroupDone = function()
	sc_back_POIGroupVisibility()
	NEXTSTATE(st_DeletePoiGroupEmpty)
end

createState("st_DeletePoiGroupEmpty")
st_DeletePoiGroupEmpty.init = function()
	MODEL.my.poi.delete_content(wCurrentGroup, MODEL.poi.find_provider("userpoi"))
	MODEL.my.poi.delete_group(wCurrentGroup, MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.execute()
	PREVSTATE()
	doDelayed(1, function()
		MODEL.ui.lst_PoiVisList.scroll_pos = wLastScrollPos
	end
	)
end

-- drag mode
sc_EasyMapClick_orig = sc_EasyMapClick
sc_EasyMapClick = function()
	sc_wBlockCheck()
	local selectedPois = MODEL.map.primary.clicked_poi_list
	if selectedPois.size() == 1 then
		currentPoi = selectedPois["@0"]
		MODEL.my.poi.select_poi(currentPoi.provider_id(), currentPoi.id())
	end
	PoiSelected = false
	gClickedPoiFlag = false
	if selectedPois.size() > 0 and (MODEL.map.primary.zoom():toInt() <= gPoiDistantDistance or vActiveState() == "st_showpoiresultonmap") then
		sc_SetPOICursorIcon()
		PoiSelected = true
		gClickedPoiFlag = true
		g_cursor_strapped = true
	elseif MODEL.map.primary.clicked_tmc_id.valid() then
		MODEL.map.primary.cursor_icon = "cursor_tmc"
		g_cursor_strapped = true
	elseif not MODEL.map.primary.clicked_speedcam_list.isempty() then
		MODEL.map.primary.cursor_icon = "cursor_speedcam"
		g_cursor_strapped = true
		sc_UpdateSpeedcamModels(MODEL.map.primary.clicked_speedcam_list[0])
	else
		MODEL.map.primary.cursor_icon = "cursor"
		g_cursor_strapped = false
	end
	if MODEL.map.primary.center_follow() then
		obs_enter_drag_mode:STOP()
		sc_dragmode(false)
		obs_enter_drag_mode:START("NO_TRIGGER")
	end
	if vActiveState() == "st_easynav" and MODEL.lua.dragMode() then
		sc_start_ExitDragMode()
	end
end
 
sc_wEasyMapDrag = function()
	if vActiveState() == "st_easynav" and MODEL.lua.dragMode() then
		sc_start_ExitDragMode()
	end
end
 
sc_wBlockCheck = function()
	MODEL.lua.wBlockValid = MODEL.route.is_segment_roadblock(MODEL.map.cursor.position(), 50)
end

sc_start_ExitDragMode = function()
	sc_Kill_wTimerExitDragModeID()
	wTimerExitDragModeID = doDelayed(1500, function()
		sc_backFromdragmode()
		primary:ONMAPCLICK(sc_EasyMapClick, 1)
		primary:ONMAPDRAGGED(sc_wEasyMapDrag, 1)
	end
	)
end


sc_wPlacesAroundCursor_onrelease = function()
	if gFlatSearchInQueue == 0 then
		MODEL.poi.copy_query("poi.flat_search", "poi.tmp_flat", 1)
		if st_ManageFavorite.isEntered then
			CLEARTOSTATE(st_ManageFavorite)
			STATE(st_FindPOIFlatList)
		end
		sc_ShowPlacesAroundCursor("fade", 0, "")
	else
		MODEL.lua.PoiListFilterString = L""
		local flat_search = MODEL.poi.flat_search
		st_FindPOIFlatList.filter_is_postfilter = false
		flat_search.ext_name_filter.name = L""
		flat_search.add_to_filter_chain("poi_result", "ext_name_filter")
		CLEARTOSTATE(st_FindPOIFlatList)
		sc_ShowPlacesAroundCursor("fade", 0, "")
	end
end

sc_wDeleteFavorite_OnRelease = function()
	local text2 = MODEL.my.map.selected_item.name()
	local newMsgBox = MODEL.screen.msgbox.new
	newMsgBox.setup(2)
	newMsgBox.set_line(1, m_i18n("Are you sure you want to delete this Favourite?"))
	newMsgBox.set_line_wstr(2, text2)
	newMsgBox.setup_button(1, "sc_wDeleteFavorite_OnRelease_OK", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	newMsgBox.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wDeleteFavorite_OnRelease_OK = function()
	MODEL.my.poi.current.remove()
	MODEL.poi.resultpoi.clear()
	MODEL.my.map.select_address(MODEL.map.cursor.position())
	sc_ResetStrappedCursor()
	if vActiveState() == "st_easynav" then
		sc_start_ExitDragMode()
	end
end
 
sc_wHistoricalTraffic_onrelease = function()
	gTrafficViewStartCenter = MODEL.map.primary.center()
	sc_NextStateAnim(st_HistoricalView, "fade", 1, "")
end

sc_wLM_DeleteWaypointMSG = function()
	local waypoints = MODEL.route.list.navigated.waypoints
	waypoints.list.index = MODEL.route.list.navigated.waypoints.strapped_waypoint_id()
	local text = (waypoints.list.index() == waypoints.list.lastindex() and translated_format(m_i18n("Are you sure you want to delete your destination?")) or translated_format(m_i18n("Are you sure you want to delete this waypoint?")))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, waypoints.list.current.WSTR.longname())
	MODEL.screen.msgbox.new.setup_button(1, "sc_wLM_DeleteWaypoint", m_i18n("Delete"), "", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wLM_DeleteWaypoint = function()
	local waypoints = MODEL.route.list.navigated.waypoints
	waypoints.list.index = MODEL.route.list.navigated.waypoints.strapped_waypoint_id()
	if waypoints.list.index() == 0 then
		if waypoints.start_is_user_selected() then
			sc_TurnOnGPSMsg()
		else
			sc_ChangeStartPointMSG()
		end
	elseif waypoints.list.size() == 0 then
		sc_ChangeStartPointMSG()
	else
		waypoints.remove()
	end
	MODEL.lua.LastDestination = MODEL.navigation.destination_name_long()
end

-- Blocked road
wBlockedFromCockpit = false

st_SetBlockedRoads.init_orig = st_SetBlockedRoads.init
st_SetBlockedRoads.init = function()
	txtTitle:SET(m_i18n("Blocked Roads"))
	MODEL.lua.wLocalMenuHide = true
end
 
st_SetBlockedRoads.done = function()
	MODEL.lua.wLocalMenuHide = false
end
 
st_ChangeBlockedRoad.exit = function()
	wBlockedFromCockpit = false
end
 
sc_ChangeBlockedRoadOK_onrelease_orig = sc_ChangeBlockedRoadOK_onrelease
sc_ChangeBlockedRoadOK_onrelease = function()
	sc_BlockedRoadsData_SaveToCurrent()
	if wBlockedFromCockpit then
		MODEL.lua.newBlockedSection = false
		PREVSTATE()
		return
	end
	CLEARTOSTATE(st_FindOnMap)
	if not CLEARTOSTATE(st_FindOnMap) then
		CLEARTOSTATE(st_SetBlockedRoads)
		PREVSTATE()
	end
	MODEL.lua.newBlockedSection = false
end
 
sc_DelBlockedRoadsMSG_orig = sc_DelBlockedRoadsMSG
sc_DelBlockedRoadsMSG = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Delete all roadblocks?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_DelBlockedRoads", m_i18n("Delete All"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_LMBlockRoadCurrentUsage = function()
	wBlockedFromCockpit = true
	sc_LMBlockRoadCurrentUsageFind()
end
 
sc_LMBlockRoadCurrentUsageFind = function()
	if sc_wBlockRoadCurrentItemFind() then
		sc_BlockedRoadsData_LoadFromCurrent()
		NEXTSTATE(st_ChangeBlockedRoad)
	else
		NEXTSTATE(st_SetBlockedRoads)
	end
end
 
sc_wBlockRoadCurrentItemFind = function()
	MODEL.route.add_roadblock(MODEL.map.cursor.position(), true, true)
	MODEL.mydata.blocked_roads.current_weekdays_all_blocked(false)
	MODEL.mydata.blocked_roads.list.setcurrent(0)
	local topLeftNeed, bottomRightNeed = MODEL.mydata.blocked_roads.get_boundrect()
	local topLeft, bottomRight = nil, nil
	local successfind = false
	MODEL.mydata.blocked_roads.delete_current()
	for i = 0, MODEL.INT.mydata.blocked_roads.list.size() - 1 do
		MODEL.mydata.blocked_roads.list.setcurrent(i)
		topLeft, bottomRight = MODEL.mydata.blocked_roads.get_boundrect()
		if topLeft == topLeftNeed and bottomRight == bottomRightNeed then
			successfind = true
			break
		end
	end
	return successfind
end
 
sc_wDeleteSegmentMSG = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Delete this roadblock?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wDeleteSegment", m_i18n("Delete"), "", "ico_Delete_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wDeleteSegment = function()
	if sc_wBlockRoadCurrentItemFind() then
		MODEL.mydata.blocked_roads.delete_current()
	else
		MODEL.route.remove_roadblock(MODEL.map.cursor.position())
		MODEL.route.recalculate()
	end
	sc_wBlockCheck()
end
 
createState("st_wBlockedRoadItem")
st_wBlockedRoadItem:useLayers(ui_BlockedRoadItem, commonLayers)
st_wBlockedRoadItem.enter = function()
	sc_BlockedRoadsData_LoadFromCurrent()
end
 
st_wBlockedRoadItem.init = function()
	txtTitle:SET(m_i18n("Blocked Road"))
end
 
sc_DelBlockedRoad_orig = sc_DelBlockedRoad
sc_DelBlockedRoad = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Delete this roadblock?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_DelBlockedRoadOK", m_i18n("Delete"), "", "ico_Delete_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_DelBlockedRoadOK = function()
	MODEL.mydata.blocked_roads.delete_current()
	sc_back()
	if MODEL.mydata.blocked_roads.list.isempty() then
		sc_back()
	end
end
 
sc_BlockRoadSectionPermanent_orig = sc_BlockRoadSectionPermanent
sc_BlockRoadSectionPermanent = function()
	MODEL.route.add_roadblock(MODEL.map.cursor.position(), true, true)
	MODEL.mydata.blocked_roads.current_weekdays_all_blocked(true)
	sc_wBlockCheck()
end
 
sc_BlockRoadSectionPermanent_lc = function()
	MODEL.route.add_roadblock(MODEL.map.cursor.position(), true, true)
	MODEL.lua.newBlockedSection = true
	CLEARTOSTATE(st_FindOnMap)
	NEXTSTATE(st_ChangeBlockedRoad)
end

--place.lua
 
wWhereAmISayed = nil
st_FindOnMap.init_orig = st_FindOnMap.init
st_FindOnMap.init = function()
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
	if not gFindOnMapEnterScript and MODEL.ui.lmSavedPos.list[0].item.type() == 1 then
		PoiSelected = true
	end
	gFindOnMapEnterScript = false
	local mapLayer = MODEL.map.primary
	local cursor = MODEL.map.cursor
	local selected_item = MODEL.my.map.selected_item
	sc_init_local_menu("ui.lm_st_FindOnMap", true)
	mapLayer.save_state(mapLayer.state())
	if MODEL.ui.lmSavedPos.list[0].item.type() == 1 and PoiSelected then
		mapLayer.enter_state("poiitem")
	else
		mapLayer.enter_state("browsemap")
	end
	MODEL.map.primary.rotate = 0
	if MODEL.lua.ItemHasJustSelected() then
		if MODEL.my.map.selected_item.type() ~= 6 then
			MODEL.map.primary.zoom = MODEL.map.primary.minzoom2d()
		end
		MODEL.lua.ItemHasJustSelected = false
	elseif MODEL.map.primary.show_pois() ~= 3 then
		MODEL.map.primary.zoom = gBrowsemapZoom
	end
	if MODEL.my.map.selected_item.type() == 1 and g_cursor_strapped then
		sc_SetPOICursorIcon()
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
	if not routeCalcIsCancelled then
		cursor.position = selected_item.position()
		if not gKeepMapPosAfterBack then
			mapLayer.center = selected_item.position()
		else
			mapLayer.center = gTmpLastMapCenterPos
			mapLayer.zoom = gBrowsemapZoom
		end
	else
		cursor.position = cursorBeforeCancel
		mapLayer.center = selected_item.position()
		vRouteCalcIsCancelled = false
	end
	sc_wBlockCheck()
	gKeepMapPosAfterBack = false
	primary:ONMAPCLICK(sc_FindOnMapClick, 1)
	mapLayer.show_cursor = true
	obs_user_browsing_map:start()
	obs_clicked_tmc_id_changed:start()
end
 
st_WhereAmI.enter = function()
	wWhereAmISayed = false
end
 
st_WhereAmI.init_orig = st_WhereAmI.init
st_WhereAmI.init = function()
	sc_init_local_menu("ui.lm_st_WhereAmI", true)
	MODEL.lua.ismapvisible = false
	txtTitle:SET(m_i18n("Where Am I?"))
	MODEL.my.map.select_address(MODEL.navigation.car.position())
	if not MODEL.navigation.is_in_simulation() then
		sc_set_Nav2D3D()
		sc_Set_Presets()
	end
	sc_set_smallmap_WhereAmI()
	sc_vehicle_size()
--	if MODEL.lua.wWhereIAmTTSInfo() and MODEL.regional.current_voice.is_tts() and not wWhereAmISayed then
--		wWhereAmISayed = true
--		sc_wsayspeech(sc_wGetTextWhereIAm(),1)
--	end
end
   
st_CursorLocation.init_orig = st_CursorLocation.init
st_CursorLocation.init = function()
	MODEL.lua.wLocalMenuHide = true
	MODEL.lua.ismapvisible = false
	txtTitle:SET(m_i18n("Cursor Location"))
end
 
st_CursorLocation.done = function()
	MODEL.lua.wLocalMenuHide = false
end
 
sc_wPlacesAroundCursor_onrelease = function()
	if gFlatSearchInQueue == 0 then
		MODEL.poi.copy_query("poi.flat_search", "poi.tmp_flat", 1)
		if st_ManageFavorite.isEntered then
			CLEARTOSTATE(st_ManageFavorite)
			STATE(st_FindPOIFlatList)
		end
		sc_ShowPlacesAroundCursor("fade", 0, "")
	else
		MODEL.lua.PoiListFilterString = L""
		local flat_search = MODEL.poi.flat_search
		st_FindPOIFlatList.filter_is_postfilter = false
		flat_search.ext_name_filter.name = L""
		flat_search.add_to_filter_chain("poi_result", "ext_name_filter")
		CLEARTOSTATE(st_FindPOIFlatList)
		sc_ShowPlacesAroundCursor("fade", 0, "")
	end
end
 
sc_FindOnMap_Select_onrelease_orig = sc_FindOnMap_Select_onrelease
sc_FindOnMap_Select_onrelease = function()
	if MODEL.lua.wInSelectHomeOffice() then
		sc_FinishSelectPositionOK()
		return
	end
	gKeepMapPosAfterBack = true
	sc_SetRoutePlanErrorMarker()
	MODEL.lua.mainMenuMode = false
	sc_GoMyRouteMenuMessage()
end
 
sc_lock_plan_mode_orig = sc_lock_plan_mode
sc_lock_plan_mode = function()
	if MODEL.lua.LockToCar() then
		MODEL.my.map.select_gcoor(MODEL.navigation.car.position())
	else
		sc_LoadTempPos()
	end
	local Pos = MODEL.my.map.selected_item.position()
	MODEL.map.cursor.position = Pos
	MODEL.map.primary.center = Pos
	if MODEL.my.map.selected_item.type() == 1 then
		sc_SetPOICursorIcon()
	else
		MODEL.map.primary.cursor_icon = "cursor_places"
	end
	sc_wBlockCheck()
end

-- gj zoom overview

sc_ExitOverview = function()
	MODEL.map.primary.camera_settings.overview_distance = 9999999
end

sc_wOverviewHighwayPause = function()
	MODEL.map.primary.camera_settings.overview_distance = 9999999
end

sc_wOverviewReset = function()
	if MODEL.map.primary.camera_settings.overview_distance() == 9999999 and wTemp_overview_distance ~= nil then
		MODEL.map.primary.camera_settings.overview_distance = wTemp_overview_distance
	end
end
 
sc_overview_check = function()
	MODEL.lua.wOverviewFlag = (wTemp_overview_distance < MODEL.navigation.distance_to_maneuver())
end


sc_MapSettings_Zoom = function()
	sc_NextStateAnim(st_MapSettings_Zoom, "horz_scroll", 1, "")
end


sc_ConvertInputDistToCurrent = function(dist)
	return float.toInt(float.new(tostring(dist)) * wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
end
 
sc_Select_wZoom_defaultzoom2dDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		MODEL.lua.wZoom_defaultzoom2d = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
 
sc_Select_wZoom_defaultzoom3dDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		MODEL.lua.wZoom_defaultzoom3d = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
 
sc_Select_wZoom_minangleDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_minangle = text
		if MODEL.lua.wZoom_maxangle() < text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_maxangleDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangle = text
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_maxangleSPDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangleSP = text
		if MODEL.lua.wZoom_maxangle() > text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_speedlowDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = float.toInt(float.new(tostring(text))* EUnits.MileToKm)
		end
		MODEL.lua.wZoom_speedlow = text
		if MODEL.lua.wZoom_speedhigh() < text then
			MODEL.lua.wZoom_speedhigh = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_speedhighDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = float.toInt(float.new(tostring(text))* EUnits.MileToKm)
		end
		MODEL.lua.wZoom_speedhigh = text
		if MODEL.lua.wZoom_speedlow() > text then
			MODEL.lua.wZoom_speedlow = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_overview_distanceDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		MODEL.lua.wZoom_overview_distance = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
 
sc_Select_wZoom_overview_zoom2dDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		MODEL.lua.wZoom_overview_zoom2d = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
 
sc_Select_wZoom_overview_zoom3dDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		MODEL.lua.wZoom_overview_zoom3d = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end
 
sc_Select_wZoom_overview_angleDone = function()
	KEY("RETURN")
	if not inpValueInteger_isempty() then
		MODEL.lua.wZoom_overview_angle = tonumber(ui.inpValueInteger.VALUE())
	end
	PREVSTATE()
end
 
createState("st_MapSettings_Zoom")
st_MapSettings_Zoom:useLayers(commonLayers, ui_MapSettings_Zoom)
st_MapSettings_Zoom.init = function()
	txtTitle:SET(m_i18n("User zoom settings"))
end

st_MapSettings_Zoom.exit = function()
	sc_Set_Presets()
end



sc_Angle_SP = function()
	local camerasettings = MODEL.map.primary.camera_settings()
	camerasettings.restore()
	camerasettings.roundabout.centery = 65
	camerasettings.presetid = 10 * (MODEL.lua.vEasyViewMode() + 1) + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		camerasettings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
		camerasettings.maxangle = MODEL.lua.wZoom_maxangleSP()
		camerasettings.angleoffset = MODEL.lua.wZoom_maxangleSP()
		camerasettings.defaultangle = MODEL.lua.wZoom_maxangleSP()
	else
		camerasettings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Angle_notSP = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.camera_settings.restore()
	mapLayer.camera_settings.roundabout.centery = 50
	mapLayer.car_posy = (MODEL.lua.vEasyMapMode() ~= EMapMode.Mode_2D and 80 or (MODEL.route.vehicle_type() == EVehicleType.Pedestrian and 70 or 80))
	mapLayer.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		mapLayer.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Set_Presets_orig = sc_Set_Presets
sc_Set_Presets = function()
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets()
	end
	MODEL.map.primary.camera_settings.restore()
	MODEL.map.primary.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		MODEL.map.primary.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Set_wUser_Presets = function()
	local settings = MODEL.map.primary.camera_settings()
	sc_Set_wUser_Presets_followzoom()
	settings.minangle = MODEL.lua.wZoom_minangle()
	settings.maxangle = MODEL.lua.wZoom_maxangle()
	settings.angleoffset = MODEL.lua.wZoom_maxangle()
	settings.defaultangle = MODEL.lua.wZoom_maxangle()
	settings.lowspeed = MODEL.lua.wZoom_speedlow()
	settings.highspeed = MODEL.lua.wZoom_speedhigh()
	if not MODEL.lua.wZoom_lockzoom() then
		settings.speedzoom = MODEL.lua.wZoom_speedzoom()
		if MODEL.lua.wZoom_speedzoom() then
			settings.speedzoom_use_minmax = true
		end
	end
	settings.speedangle = MODEL.lua.wZoom_speedangle()
	if MODEL.lua.wZoom_speedangle() then
		settings.speedangle_use_minmax = true
	end
	settings.overview_enabled = MODEL.lua.wZoom_overview_enabled() and not MODEL.lua.wZoom_lockzoom()
	if MODEL.lua.wZoom_overview_enabled() then
		settings.overview_distance = MODEL.lua.wZoom_overview_distance()
		settings.overview_zoom2d = MODEL.lua.wZoom_overview_zoom2d()
		settings.overview_zoom3d = MODEL.lua.wZoom_overview_zoom3d()
		settings.overview_angle = MODEL.lua.wZoom_overview_angle()
	end
end
 
sc_Set_wUser_Presets_followzoom = function()
	if MODEL.lua.wUserZoomSetting() and MODEL.lua.wZoom_lockzoom() then
		MODEL.map.primary.zoom_follow = false
		MODEL.map.primary.zoom = (MODEL.map.primary.mode() == "3d" and MODEL.lua.wZoom_defaultzoom3d() or MODEL.lua.wZoom_defaultzoom2d())
	else
		MODEL.map.primary.zoom_follow = not MODEL.lua.dragMode()
	end
end
 
sc_Easy3D_orig = sc_Easy3D
sc_Easy3D = function()
	local mapLayer = MODEL.map.primary()
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("navmap3d", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_3D()
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
end
 
sc_Easy2D_orig = sc_Easy2D
sc_Easy2D = function()
	local mapLayer = MODEL.map.primary()
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dheadup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
		mapLayer.zoom_follow = false
		mapLayer.car_posy = 70
		mapLayer.center_posy = 70
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.car_posy = 80
		mapLayer.center_posy = 80
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end
 
sc_Easy3DFromDragmode_orig = sc_Easy3DFromDragmode
sc_Easy3DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("navmap3d", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
		mapLayer.rotate_follow = false
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
		mapLayer.rotate_follow = true
	end
end
 
sc_Easy2DFromDragmode_orig = sc_Easy2DFromDragmode
sc_Easy2DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dheadup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.breadcrumbs = true
		mapLayer.center_posy = 50
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.breadcrumbs = false
		mapLayer.center_posy = 80
	end
end
 
sc_Set_Follow_On_orig = sc_Set_Follow_On
sc_Set_Follow_On = function()
	local mapLayer = MODEL.map.primary()
	if MODEL.route.vehicle_type() ~= EVehicleType.Pedestrian then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
	mapLayer.center_follow = true
	mapLayer.rotate_follow = true
end

-- simulate

tSimControlsObjectsNew = {"spr_SC_bg", "btn_ManNext", "spr_ManNext", "btn_sim_play", "spr_sim_play", "btn_sim_pause", "spr_sim_pause", "btn_ManPrev", "spr_ManPrev", "btnSpeedSimUp", "sprSpeedSimUp", "btnSpeedSimNormal", "sprSpeedSimNormal", "btnSpeedSimDown", "sprSpeedSimDown"}

sc_StartFadeSimControls_orig = sc_StartFadeSimControls
sc_StartFadeSimControls = function(from, to, time)
	for cntr = 1, #tSimControlsObjectsNew do
		_G[tSimControlsObjectsNew[cntr]]:BLENDALPHA(from, to, time)
	end
	scroll_SC:ALPHA(to)
end
 
sc_RestartSimControlsDelay_orig = sc_RestartSimControlsDelay
sc_RestartSimControlsDelay = function()
	sc_ResetSimControlsDelay()
	sc_StartFadeSimControls(gSimControlsFadeMin, gSimControlsFadeMax, gSimControlsFadeInTime)
	gSimControlsFadeDelayID = doDelayed(200, "sc_FadeOutSimControls()")
end

-- restart 

sc_wRestart_OnRelease = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("The program will restart."))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wRestart_OnReleaseDone", m_i18n("Restart"), "", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wRestart_OnReleaseDone = function()
	SAVESETTINGS()
	NEXTSTATE(RestartState)
	doDelayed(25, APP_RESTART)
end

-- user data management
sc_UDM_UserData_Enter = function()
	sc_NextStateAnim(st_gj_UDManagement, "horz_scroll", 1, "")
end

createState("st_gj_UDManagement")
st_gj_UDManagement:useLayers(commonLayers, ui_gj_UDManagement)
st_gj_UDManagement.init = function()
	txtTitle:SET(m_i18n("User Data Management"))
end

sc_UDM_UserData_Backup = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Do you want to backup your current settings and data?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_UDM_UserData_Backup_OK", m_i18n("Backup User Data"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_UDM_UserData_Backup_OK = function()
	gj_max_loop, gj_loop = 15, 0
	SAVESETTINGS()
	START_APPLICATION("utility/backup.exe","")
	doDelayed(100, "sc_UserDataBackup_filecheck()")
end

sc_UserDataBackup_filecheck = function()
		local oasisFiles = MODEL.oasis.files()
		oasisFiles.useful_dirs_only = true
		oasisFiles.selectable_dir = true
		oasisFiles.unroll_dirs = true
		oasisFiles.path = L"%app%/utility"
		oasisFiles.create_file_props = false
		oasisFiles.initialize_data()
		MODEL.oasis.files.list.index = 0
		obs_Files_UserBackup_Finished:START("NO_TRIGGER")
--		START_APPLICATION("utility/beep.exe",",pik.wav")
end

sc_UserDataBackup_check_done = function()
	doDelayed(15, "sc_UserDataBackup_check_done2()")
end

sc_UserDataBackup_check_done2 = function()
	obs_Files_UserBackup_Finished:STOP()
	gj_loop = gj_loop + 1
	local fn = L""
	local findResult, findExe = 0, 0
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		fn = MODEL.oasis.files.list[i].fname()
		if wstring.wmatch(wstring.upper(fn),L"BACKUP.OK") then
			findResult = 1
		elseif wstring.wmatch(wstring.upper(fn),L"BACKUP.NFRUN") then
			findExe = 1
		end
	end
	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false
	if findExe == 1 and findResult == 1 then
		sc_UDM_UserData_Backup_Success()
	else
		if gj_loop < gj_max_loop then
			doDelayed(100, "sc_UserDataBackup_filecheck()")
		else
			sc_UDM_UserData_Backup_Failed()
		end
	end
end
 
sc_UDM_UserData_Backup_Success = function()
	MODEL.screen.msgbox.new.setup(1)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Database was backed up successfully."))
	MODEL.screen.msgbox.new.setup_button(1, "")
	MODEL.screen.msgbox.create_new()
end
 
sc_UDM_UserData_Backup_Failed = function()
	MODEL.screen.msgbox.new.setup(1)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Database backup failed!\nCheck Storage Card or Backup utility configuration."))
	MODEL.screen.msgbox.new.setup_button(1, "")
	MODEL.screen.msgbox.create_new()
end
 
sc_UDM_UserData_Restore = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("All your settings and saved data will be lost since the last backup."))
	MODEL.screen.msgbox.new.setup_button(1, "sc_UDM_UserData_Restore_OK", m_i18n("Restore User Data"), "", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_UDM_UserData_Restore_OK = function()
	START_APPLICATION("utility/restore.exe",",1")
	doDelayed(100, function()
		local oasisFiles = MODEL.oasis.files()
		oasisFiles.useful_dirs_only = true
		oasisFiles.selectable_dir = true
		oasisFiles.unroll_dirs = true
		oasisFiles.path = L"%app%/utility"
		oasisFiles.create_file_props = false
		oasisFiles.initialize_data()
		MODEL.oasis.files.list.index = 0
		obs_Files_UserRestore_Finished:START("NO_TRIGGER")
	end
	)
end
 
sc_UserDataRestore_check_done = function()
	obs_Files_UserRestore_Finished:STOP()
	local fn = L""
	local findResult, findExe = 0, 0
	for i = 0, MODEL.oasis.files.list.size() - 1 do
		fn = MODEL.oasis.files.list[i].fname()
		if wstring.wmatch(wstring.upper(fn),L"RESTORE.OK") then
			findResult = 1
		elseif wstring.wmatch(wstring.upper(fn),L"RESTORE.NFRUN") then
			findExe = 1
		end
	end

	MODEL.oasis.files.deinitialize_data()
	MODEL.oasis.files.unroll_dirs = false

	if findExe == 1 and findResult == 1 then
		NEXTSTATE(RestartState)
		doDelayed(15, function()
		START_APPLICATION("utility/restore.exe",",2")
		doDelayed(1,EXIT)
		end
		)
	else
		sc_UDM_UserData_Restore_Failed()
	end
end

sc_UDM_UserData_Restore_Failed = function()
	MODEL.screen.msgbox.new.setup(1)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Database restore failed!"))
	MODEL.screen.msgbox.new.setup_button(1, "")
	MODEL.screen.msgbox.create_new()
end
 
-- toll

sc_gj_DoToll = function()
  MODEL.route.allow_toll = not MODEL.route.allow_toll()
  MODEL.route.saverouteparams()
  MODEL.route.recalculate()
  doDelayed(30, function()
	MODEL.lua.vEasyNavMapMenuOpen = false
  end
  )
end

-- position

createState("st_gjUserPosition")
st_gjUserPosition:useLayers(backgroundLayers, ui_gjUserPosition)
st_gjUserPosition.init = function()
	txtTitle:SET(m_i18n("Select position"))
	MODEL.lua.gjShowPosInfo = false
end

sc_gj_open_ListPosition = function()
	sc_NextStateAnim(st_gjUserPosition, "horz_scroll", 1, "")
end

sc_gjUserPositionAdd_OnRelease_OK = function(PosType)
    local gcoor = MODEL.navigation.car.position()
	local gcity = MODEL.navigation.car.address.city()
	local gstreet = MODEL.navigation.car.address.street()
	local SpeedLimit = MODEL.warning.driveralert.speed_limit()
	local CurrentSpeed = MODEL.navigation.car.current_speed()
	local glat = Format_GeoCoord(gcoor,EGeoCoordDisplayMode.Latitude_Only)
	local glong = Format_GeoCoord(gcoor,EGeoCoordDisplayMode.Longitude_Only)
	
	if gcity == L"" then
		gcity = gstreet
	else
	   gcity = gcity .. L", " .. gstreet
	end
	
	ui.gjUserPositionList:add({plat=glat, plong=glong, paddr=gcity, pdate=sc_DateToWStr(MODEL.gps.current_date()), ptime=MODEL.other.format_time_dayperiod(MODEL.gps.current_time(), 0, 0), pspeedlim=SpeedLimit,  pspeed=CurrentSpeed,  ptype=PosType})
	MODEL.ui.gjUserPositionList.save()
	sc_gjShowHelpText(m_i18n("Position saved!"))
end


sc_gjUserPositionInfo_OnRelease = function()
	gj_pdatText:SET(m_i18n(MODEL["*"].pdate() .. L" " .. MODEL["*"].ptime()))
	gj_pcordText:SET(m_i18n(MODEL["*"].plat() .. L" " .. MODEL["*"].plong()))
	gj_paddrText:SET(m_i18n(MODEL["*"].paddr()))
	
	local text = m_i18n(MODEL["*"].pspeedlim())
	if text == L"0" then
		text = "!"
	end
	gj_plimspeedText:SET(text)	
	gj_pcrspeedText:SET(m_i18n(MODEL["*"].pspeed()))
	
	MODEL.lua.gjTypePosInfo = m_i18n(MODEL["*"].ptype())
	
	MODEL.lua.gjShowPosInfo = true
end


sc_gj_UserPositionDel_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete this position from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL["*"].pdate() .. L" " .. MODEL["*"].ptime())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserPositionDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end

sc_gjUserPositionDel_OnRelease_OK = function()
	MODEL.ui.gjUserPositionList.remove(MODEL.ui.gjUserPositionList.list.index())
	MODEL.ui.gjUserPositionList.save()
end


sc_gj_UserPositionAll_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete all positions from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserPositionAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end


sc_gjUserPositionAll_OnRelease_OK = function()
	MODEL.ui.gjUserPositionList.clear()
	MODEL.ui.gjUserPositionList.save()
end
 
sc_gjUserPositionFindOnRelease = function()
	local index = MODEL.ui.gjUserPositionList.index()
	local plat = MODEL.ui.gjUserPositionList[index].plat()
	local plong = MODEL.ui.gjUserPositionList[index].plong()
	if MODEL.lua.Utm() then
		local zone_number, zone_letter = parse_zone(MODEL.lua.gcoor_zonetext())
		MODEL.lua.gcoor_to_find = GCOOR.new({zone_number = zone_number, zone_letter = zone_letter, x = tonumber(plat), y = tonumber(plong)})
	else
		local temp = var.new()
		temp:SET(plat)
		MODEL.regional.unlocalize_gcoor(temp)
		local geocoord_input_lat = parse_gcoor(tostring(temp()))
		ASSERT(geocoord_input_lat ~= nil)
		temp:SET(plong)
		MODEL.regional.unlocalize_gcoor(temp)
		local geocoord_input_lon = parse_gcoor(tostring(temp()))
		ASSERT(geocoord_input_lon ~= nil)
		MODEL.lua.gcoor_to_find = GCOOR.new({lat = geocoord_input_lat, lon = geocoord_input_lon})
	end
	sc_Input_GeoCoord_Ok()
end

-- ua speedcam fix
sc_wGetSCCorrectionLimit = function(limit,type,country)
    if not (country:lower() == "_ukr" and sc_GetSysEntry("warning", "speedlimit_ua_correction", 1)) then
        return limit
    elseif type == 1 or type == 4 then
        return (((limit/EUnits.MileToKm):toInt())*EUnits.MileToKm):toInt()
    else
        local value = (limit/EUnits.MileToKm):toInt()
        return (value + (limit > (value * EUnits.MileToKm):toInt() and (limit - (value * EUnits.MileToKm):toInt()) or 0))
    end
end

sc_SaveSpeedcam_orig = sc_SaveSpeedcam
sc_SaveSpeedcam = function()
   if not sc_GetSpeedCamCatValue(MODEL.lua.SpeedCam_Type(), "speedlimit") then
     MODEL.lua.SpeedCam_SpeedLimit = 0
   elseif MODEL.lua.SpeedCam_SpeedLimit() == 0 then
     MODEL.lua.SpeedCam_SpeedLimit = (MODEL.map.cursor.address.country():lower() == "_ukr" and sc_GetSysEntry("warning", "speedlimit_ua_correction", 1) and sc_GetSegmentSpeedLimit()) or 0
   end

--	if MODEL.lua.SpeedCam_Type() == 6 then
--    MODEL.lua.SpeedCam_SpeedLimit = 0
--	end

    if not sc_SpeedcameraUseRoadSpeedLimit(MODEL.lua.SpeedCam_Type()) then
     MODEL.lua.SpeedCam_SpeedLimit = 0
    end


   if MODEL.lua.managespeedcam() then
     MODEL.warning.manage.update_speedcam(MODEL.lua.SpeedCam_ID(), MODEL.lua.SpeedCam_Type(), MODEL.lua.SpeedCam_SpeedLimit(), MODEL.lua.SpeedCam_Direction(), MODEL.lua.SpeedCam_Direction_type())
   else
     MODEL.warning.manage.add_speedcam(MODEL.lua.SpeedCam_Pos(), MODEL.lua.SpeedCam_Type(), MODEL.lua.SpeedCam_SpeedLimit(), MODEL.lua.SpeedCam_Direction(), MODEL.lua.SpeedCam_Direction_type())
     if MODEL.EXISTS.warning.speedcam.community_speedcam_enabled() and MODEL.lua.SpeedCam_Type() ~= 3 then
       MODEL.warning.manage.add_community_speedcam(MODEL.lua.SpeedCam_Pos(), MODEL.lua.SpeedCam_Type(), MODEL.lua.SpeedCam_SpeedLimit(), MODEL.lua.SpeedCam_Direction(), MODEL.lua.SpeedCam_Direction_type(), 0)
     end
   end
  MODEL.map.primary.update_clicked_speedcam_list()
  sc_CopySpeedCamUserList()
  sc_UpdateCameraCursorIcon()
  PREVSTATE()
end

--bluetooth
sc_Show_BTSettings_orig = sc_Show_BTSettings
sc_Show_BTSettings = function()
	if MODEL.other.bluetooth.available() then
		MODEL.other.bluetooth.show_manager()
	else
		local gjmBTapp = var.new()
		local gjmBTpar = var.new()
		gjmBTapp = sc_GetSysEntry("bluetooth", "btappl", "btonoff.exe")
		gjmBTpar = sc_GetSysEntry("bluetooth", "btparam", "")
		doDelayed(5, function()
			START_APPLICATION(gjmBTapp,gjmBTpar)
		end
		)
		sc_back_to_cockpit()
	end
end

-- city sound
tmpcity = nil
sc_gj_citychange = function()
  if MODEL.lua.vgjCityShow() then
	local name_city = MODEL.navigation.car.address.city()
	if name_city ~= L"" then     
		if MODEL.lua.vgjCitySoundName() ~= L"" then
			if tmpcity ~= name_city then
 				sc_gjplaysound(MODEL.lua.vgjCitySoundName(), MODEL.lua.vgjCitySoundVolume())
				tmpcity = name_city
			end	
		end			
	 end
  end	
end


